{-# LANGUAGE MultiParamTypeClasses #-}
module Language.SpirV.SelectionControl where

import Data.Word (Word32)
import Language.SpirV.SpirEnum
import qualified Language.SpirV.Capability as Capability


-- | <https:\/\/www.khronos.org\/registry\/spir-v\/specs\/1.0\/SPIRV.html#_a_id_selection_control_a_selection_control Source for Selection Control>
data SelectionControl =
    None
  | Flatten
  | DontFlatten
  deriving(Read, Show, Eq, Ord)

instance SpirEnum SelectionControl Word32 where
  toWord None = 0
  toWord Flatten = 1
  toWord DontFlatten = 2

  fromWord 0 = Just None
  fromWord 1 = Just Flatten
  fromWord 2 = Just DontFlatten
  fromWord _ = Nothing

  
  requiredCapabilities _ = []
